//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class PeriodicTorsionForce : Force {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal PeriodicTorsionForce(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.PeriodicTorsionForce_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(PeriodicTorsionForce obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~PeriodicTorsionForce() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_PeriodicTorsionForce(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public PeriodicTorsionForce() : this(OpenMMSwigPINVOKE.new_PeriodicTorsionForce(), true) {
  }

  public int getNumTorsions() {
    int ret = OpenMMSwigPINVOKE.PeriodicTorsionForce_getNumTorsions(swigCPtr);
    return ret;
  }

  public int addTorsion(int particle1, int particle2, int particle3, int particle4, int periodicity, double phase, double k) {
    int ret = OpenMMSwigPINVOKE.PeriodicTorsionForce_addTorsion(swigCPtr, particle1, particle2, particle3, particle4, periodicity, phase, k);
    return ret;
  }

  public void getTorsionParameters(int index, SWIGTYPE_p_int particle1, SWIGTYPE_p_int particle2, SWIGTYPE_p_int particle3, SWIGTYPE_p_int particle4, SWIGTYPE_p_int periodicity, SWIGTYPE_p_double phase, SWIGTYPE_p_double k) {
    OpenMMSwigPINVOKE.PeriodicTorsionForce_getTorsionParameters(swigCPtr, index, SWIGTYPE_p_int.getCPtr(particle1), SWIGTYPE_p_int.getCPtr(particle2), SWIGTYPE_p_int.getCPtr(particle3), SWIGTYPE_p_int.getCPtr(particle4), SWIGTYPE_p_int.getCPtr(periodicity), SWIGTYPE_p_double.getCPtr(phase), SWIGTYPE_p_double.getCPtr(k));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setTorsionParameters(int index, int particle1, int particle2, int particle3, int particle4, int periodicity, double phase, double k) {
    OpenMMSwigPINVOKE.PeriodicTorsionForce_setTorsionParameters(swigCPtr, index, particle1, particle2, particle3, particle4, periodicity, phase, k);
  }

  public void updateParametersInContext(Context context) {
    OpenMMSwigPINVOKE.PeriodicTorsionForce_updateParametersInContext(swigCPtr, Context.getCPtr(context));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setUsesPeriodicBoundaryConditions(bool periodic) {
    OpenMMSwigPINVOKE.PeriodicTorsionForce_setUsesPeriodicBoundaryConditions(swigCPtr, periodic);
  }

  public override bool usesPeriodicBoundaryConditions() {
    bool ret = OpenMMSwigPINVOKE.PeriodicTorsionForce_usesPeriodicBoundaryConditions(swigCPtr);
    return ret;
  }

}

}
